function [op op2]=estimation_generalized_diversity(received_signal1,received_signal2,time_vector,symbol_time,Ns,M,fc,K,symbol_period,var,Nt)

if(var==1)
    i=1:M;
    A=2*i-1-M;
    carriersmatrix=zeros(M,length(symbol_time));

    for r=1:M
        carriersmatrix(r,:)=A(r).*cos(2*pi*fc.*symbol_time).*Nt;
    end

end   

if(var==2)

    i=1:M;
    carrier_phase= 2 *pi*(i-1)/M;
    carriersmatrix=zeros(M,length(symbol_time));

    for r=1:M
        carriersmatrix(r,:)=cos(2*pi*fc.*symbol_time+carrier_phase(r)).*Nt;
    end

end

if(var==3)
    M_new = sqrt(M);
    i=1:M_new;
    u=[];
    u=i;
    carrier_phase= 2 *pi*(i-1)/M_new;
    carriersmatrix=zeros(M,length(symbol_time));
    aux_var=0;
    
    for r=1:M_new
        for p=1:M_new
            aux_var =aux_var+1;
            carriersmatrix(aux_var,:)=u(r)*cos(2*pi*fc.*symbol_time+carrier_phase(p)).*Nt;
    
        end
    end

end  

if(var==4)
    i=1:M;
    u =[];
    u=2*i-1-M;
    deltaf=1/symbol_period;
    carriersmatrix=zeros(M,length(symbol_time));

    for r=1:M
        
        carriersmatrix(r,:)=cos(2*pi*fc.*symbol_time+2*pi*u(r)*deltaf*symbol_time).*Nt;
    end

end   

for s=1:Ns
    
        rec1=received_signal1(1,(s-1)*length(symbol_time)+1:(s)*length(symbol_time));
        rec2=received_signal2(1,(s-1)*length(symbol_time)+1:(s)*length(symbol_time));
        temp3=0;
        for k=1:length(symbol_time)
            temp1=rec1(1,k)-carriersmatrix(:,k);
            temp2=rec2(1,k)-carriersmatrix(:,k);
            
            temp3=temp3+(temp1.^2)+(temp2.^2);
        end
        
        d_metric=transpose(temp3);
        dmin=min(d_metric);
        index(1,s)=find(d_metric==dmin,1)-1;
        
end

for k=1:Ns
    for m=1:length(symbol_time)
    op(1,m+(k-1)*length(symbol_time))=index(1,k);
    end
end

op2=[];
for i=1:length(index)
    op2=[op2 carriersmatrix(index(i)+1,:)];
end